# Class VulkanOffset2D

java.lang.Object
com.io7m.jcoronado.api.VulkanOffset2D

All Implemented Interfaces:
  `VulkanOffset2DType`

public final class VulkanOffset2D extends Object implements VulkanOffset2DType
Structure specifying a two-dimensional offset.

See Also:
  - "VkOffset2D"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanOffset2D.Builder`
  Builds instances of type `VulkanOffset2D`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanOffset2D.Builder`
  `builder()`
  Creates a builder for `VulkanOffset2D`.
  `static VulkanOffset2D`
  `copyOf(VulkanOffset2DType instance)`
  Creates an immutable copy of a `VulkanOffset2DType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanOffset2D` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `x`, `y`.
  `static VulkanOffset2D`
  `of(int x, int y)`
  Construct a new immutable `VulkanOffset2D` instance.
  `String`
  `toString()`
  Prints the immutable value `VulkanOffset2D` with attribute values.
  `final VulkanOffset2D`
  `withX(int value)`
  Copy the current immutable object by setting a value for the `x` attribute.
  `final VulkanOffset2D`
  `withY(int value)`
  Copy the current immutable object by setting a value for the `y` attribute.
  `int`
  `x()`
  `int`
  `y()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x

    public int x()
    Specified by:
      `x` in interface `VulkanOffset2DType`
    Returns:
      The x offset

  - ### y

    public int y()
    Specified by:
      `y` in interface `VulkanOffset2DType`
    Returns:
      The y offset

  - ### withX

    public final VulkanOffset2D withX(int value)
    Copy the current immutable object by setting a value for the `x` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x
    Returns:
      A modified copy of the `this` object

  - ### withY

    public final VulkanOffset2D withY(int value)
    Copy the current immutable object by setting a value for the `y` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for y
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanOffset2D` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x`, `y`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanOffset2D` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanOffset2D of(int x, int y)
    Construct a new immutable `VulkanOffset2D` instance.
    Parameters:
      `x` - The value for the `x` attribute
      `y` - The value for the `y` attribute
    Returns:
      An immutable VulkanOffset2D instance

  - ### copyOf

    public static VulkanOffset2D copyOf(VulkanOffset2DType instance)
    Creates an immutable copy of a `VulkanOffset2DType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanOffset2D instance

  - ### builder

    public static VulkanOffset2D.Builder builder()
    Creates a builder for `VulkanOffset2D`.

         VulkanOffset2D.builder()
            .setX(int) // required x
            .setY(int) // required y
            .build();

    Returns:
      A new VulkanOffset2D builder